<?php

    /**

        * @File: validation.php

        * @Author: Ilko Ivanov

        * @Author e-mail: ilko.iv@gmail.com

        * @Publisher: Avalon Ltd

        * @Publisher e-mail: home@avalonbg.com

        * @Owner: Avalon Ltd

        * @Version: 1.0.10

	*/

/**

 * @since 1.5.0

 */

class TbigrpaymentValidationModuleFrontController extends ModuleFrontController

{

	/**

	 * @see FrontController::postProcess()

	 */

	public function postProcess()

	{

		$tbigr_type = (string)Tools::getValue('tbigr_type');

		

		$cart = $this->context->cart;

		if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)

			Tools::redirect('index.php?controller=order&step=1');

		// Check that this payment option is still available in case the customer changed his address just before the end of the checkout process

		$authorized = true;

		foreach (Module::getPaymentModules() as $module)

			if ($module['name'] == 'tbigrpayment')

			{

				$authorized = true;

				break;

			}

		if (!$authorized)

			die($this->module->l('This payment method is not available.', 'validation'));

		$customer = new Customer($cart->id_customer);

		if (!Validate::isLoadedObject($customer))

			Tools::redirect('index.php?controller=order&step=1');

		$currency = $this->context->currency;

		$total = (float)$cart->getOrderTotal(true, Cart::BOTH);

		$mailVars = array(

			'{bankwire_owner}' => 'owner',

			'{bankwire_details}' => nl2br('details'),

			'{bankwire_address}' => nl2br('address')

		);

		

		$tbigr_products = $cart->getProducts(true);

		$tbigr_products_price = $cart->getordertotal(true);

		$tbigr_unicid = (string)Configuration::get('credittbigr_unicid');

		$tbigr_store_id = (string)Configuration::get('credittbigr_store_id');

		$tbigr_username = (string)Configuration::get('credittbigr_username');

		$tbigr_password = (string)Configuration::get('credittbigr_password');

		$tbigr_iris_iban = (string)Configuration::get('credittbigr_iris_iban');

		

		$tbigr_ch = curl_init();

		curl_setopt($tbigr_ch, CURLOPT_SSL_VERIFYPEER, false);

		curl_setopt($tbigr_ch, CURLOPT_RETURNTRANSFER, true);

		curl_setopt($tbigr_ch, CURLOPT_MAXREDIRS, 2);

		curl_setopt($tbigr_ch, CURLOPT_TIMEOUT, 5);

		curl_setopt($tbigr_ch, CURLOPT_URL, TBIGR_LIVEURL . '/function/getparameters.php?cid='.$tbigr_unicid);

		$paramstbigr=json_decode(curl_exec($tbigr_ch), true);

		curl_close($tbigr_ch);

		

		$tbigr_products_id = '';

		$tbigr_products_q = '';

		$tbigr_products_n = '';

			

		$ident = 0;

		$tbigr_items = array();

		$tbigr_api_items = array();

		foreach ($tbigr_products as $tbigr_product){

			$tbigr_items[$ident]['name'] = preg_replace("/[^A-Za-z0-9?! ]/","",$tbigr_product['name']);

			$tbigr_api_items[$ident]['name'] = preg_replace("/[^A-Za-z0-9?! ]/","",$tbigr_product['name']);

			$tbigr_api_items[$ident]['description'] = '';

			$tbigr_quantity = $tbigr_product['quantity'];

			$tbigr_items[$ident]['qty'] = "$tbigr_quantity";

			$tbigr_api_items[$ident]['qty'] = "$tbigr_quantity";

			$tbigr_price = $tbigr_product['price_wt'];

			$tbigr_items[$ident]['price'] = "$tbigr_price";

			$tbigr_api_items[$ident]['price'] = "$tbigr_price";

			$tbigr_category = $tbigr_product['id_category_default'];

			$tbigr_items[$ident]['category'] = "$tbigr_category";

			$tbigr_api_items[$ident]['category'] = "$tbigr_category";

			$tbigr_product_id = $tbigr_product['id_product'];

			$tbigr_items[$ident]['sku'] = "$tbigr_product_id";

			$tbigr_image = Image::getCover($tbigr_product['id_product']);

			$tbigr_link = new Link;

			$tbigr_imagePath = $tbigr_link->getImageLink($tbigr_product['link_rewrite'], $tbigr_image['id_image'], 'home_default');

			$tbigr_items[$ident]['ImageLink'] = "$tbigr_imagePath";

			$tbigr_api_items[$ident]['ImageLink'] = "$tbigr_imagePath";

			$ident++;

		}

		

		$this->module->validateOrder($cart->id, Configuration::get('PS_OS_TBIGRPAYMENT'), $total, $this->module->displayName, NULL, $mailVars, (int)$currency->id, false, $customer->secure_key);

		$order_conf_link = $this->context->link->getPageLink('order-confirmation');

        if (strpos($order_conf_link, '?') !== FALSE) {

            $url_separator = '&';

        } else {

            $url_separator = '?';

        }

			

		$tbigr_url = TBIGR_LIVEURL . "/function/status.php";

		$order_id = $this->module->currentOrder;

		$tbigr_address_delivery_id = isset($this->context->cart->id_address_delivery) ? $this->context->cart->id_address_delivery : '';

		$tbigr_address_invoice_id = isset($this->context->cart->id_address_invoice) ? $this->context->cart->id_address_invoice : '';

		$tbigr_addresses = $this->context->customer->getAddresses($this->context->customer->id_lang);

		foreach ($tbigr_addresses as $tbigr_address){

			if ($tbigr_address['id_address'] == $tbigr_address_delivery_id){

				$tbigr_shipping_addresses = $tbigr_address;

			}

			if ($tbigr_address['id_address'] == $tbigr_address_invoice_id){

				$tbigr_billing_addresses = $tbigr_address;

			}

		}

			

		$tbigr_fname = isset($this->context->customer->firstname) ? $this->context->customer->firstname : '';

		$tbigr_lname = isset($this->context->customer->lastname) ? $this->context->customer->lastname : '';

		$tbigr_cnp = '';

		$tbigr_email = isset($this->context->customer->email) ? $this->context->customer->email : '';

		$tbigr_phone = isset($tbigr_shipping_addresses['phone']) ? $tbigr_shipping_addresses['phone'] : '';

		$tbigr_billing_address = isset($tbigr_billing_addresses['address1']) ? $tbigr_billing_addresses['address1'] : '';

		$tbigr_billing_city = isset($tbigr_billing_addresses['city']) ? $tbigr_billing_addresses['city'] : '';

		$tbigr_billing_county = isset($tbigr_billing_addresses['state']) ? $tbigr_billing_addresses['state'] : '';

		$tbigr_shipping_address = isset($tbigr_shipping_addresses['address1']) ? $tbigr_shipping_addresses['address1'] : '';

		$tbigr_shipping_city = isset($tbigr_shipping_addresses['city']) ? $tbigr_shipping_addresses['city'] : '';

		$tbigr_shipping_county = isset($tbigr_shipping_addresses['state']) ? $tbigr_shipping_addresses['state'] : '';

		$tbigr_person_type = '';

		$tbigr_net_income = '';

		$tbigr_instalments = '';

			

		// Create tbigr order i data base

		$tbigr_add_ch = curl_init();

		curl_setopt($tbigr_add_ch, CURLOPT_SSL_VERIFYPEER, false);

		curl_setopt($tbigr_add_ch, CURLOPT_RETURNTRANSFER, true);

		curl_setopt($tbigr_add_ch, CURLOPT_MAXREDIRS, 2);

		curl_setopt($tbigr_add_ch, CURLOPT_TIMEOUT, 5);

		curl_setopt($tbigr_add_ch, CURLOPT_URL, TBIGR_LIVEURL . '/function/addorders.php?cid='.$tbigr_unicid);

		curl_setopt($tbigr_add_ch, CURLOPT_POST, 1);

		

		$tbigr_post = array(

			'store_id'		=>	$tbigr_store_id,

			'order_id'		=>	$order_id,

			'type'      	=>  strtoupper($tbigr_type),

			'back_ref'		=>	$tbigr_url,

			'order_total'	=>	$tbigr_products_price,

			'username'		=>	$tbigr_username,

			'password'		=>	$tbigr_password,

			'customer'		=>	array(

				'fname'				=>	$tbigr_fname,

				'lname'				=>	$tbigr_lname,

				'cnp'				=>	$tbigr_cnp,

				'email'				=>	$tbigr_email,

				'phone'				=>	$tbigr_phone,

				'billing_address'	=>	$tbigr_billing_address,

				'billing_city'		=>	$tbigr_billing_city,

				'billing_county'	=>	$tbigr_billing_county,

				'shipping_address'	=>	$tbigr_shipping_address,

				'shipping_city'		=>	$tbigr_shipping_city,

				'shipping_county'	=>	$tbigr_shipping_county,

				'person_type'		=>	'',

				'net_income'		=>	'',

				'instalments'		=>	'',

			),

			'items'			=>	$tbigr_items

		);

		

		curl_setopt($tbigr_add_ch, CURLOPT_POSTFIELDS, http_build_query($tbigr_post));

		$paramstbigradd=json_decode(curl_exec($tbigr_add_ch), true);

		curl_close($tbigr_add_ch);				

		// Create tbigr order i data base

		

		if (isset($paramstbigradd['status']) && ($paramstbigradd['status'] == 'Yes')){

			// save to tbiorders file

			$tbigr_tempcontent = file_get_contents(_PS_MODULE_DIR_ . 'tbigrpayment/keys/tbigrorders.json');

			if ($tbigr_tempcontent != false){

				$tbigr_orders = json_decode($tbigr_tempcontent);

				// test over 1000

				if (is_array($tbigr_orders) && (count($tbigr_orders) >= 1000)){

					array_shift($tbigr_orders);

				}

				$tbigr_order_current = array(

					"order_id" => $order_id,

					"order_status" => "Draft"

				);

				$key = array_search($order_id, array_map(

					function($o) {

						return $o->order_id;

					}, 

					$tbigr_orders));

				if ($key === false){

					array_push($tbigr_orders, $tbigr_order_current);

				}

				$jsondata = json_encode($tbigr_orders);

				file_put_contents(_PS_MODULE_DIR_ . 'tbigrpayment/keys/tbigrorders.json', $jsondata);

			}

				

			// send to softinteligens

			$tbigr_post_arr = array(

				'firstname'      	=> $tbigr_fname,

				'lastname'      	=> $tbigr_lname,

				'surname'      		=> '',

				'pin'   			=> $tbigr_cnp,

				'origin'			=> 'POS_Online',

				'resellercode'		=> $tbigr_store_id,

				'email'         	=> $tbigr_email,

				'phone'         	=> $tbigr_phone,

				'billingaddress'	=> array(

					'country'			=> '',

					'county'        	=> $tbigr_billing_county,

					'city'         	 	=> $tbigr_billing_city,

					'streetname'      	=> $tbigr_billing_address,

					'streetno'			=> '',

					'buildingno'		=> '',

					'entranceno'		=> '',

					'floorno'			=> '',

					'apartmentno'		=> '',

					'postalcode'		=> ''

				),

				'deliveryaddress'	=> array(

					'country'			=> '',

					'county'        	=> $tbigr_shipping_county,

					'city'         	 	=> $tbigr_shipping_city,

					'streetname'      	=> $tbigr_shipping_address,

					'streetno'			=> '',

					'buildingno'		=> '',

					'entranceno'		=> '',

					'floorno'			=> '',

					'apartmentno'		=> '',

					'postalcode'		=> ''

				),

				'orderid'   		=> $paramstbigradd['newid'],

				'bankingproductcode'=> '',

				'promo'				=> '0',

				'installments'		=> $tbigr_instalments,

				'ordertotal'		=> $tbigr_products_price,

				'installmentamount'	=> '',

				'items' 			=> $tbigr_api_items,

				'siteurl'			=> TBIGR_LIVEURL,

				'statusurl'			=> $tbigr_url

			);

				

			// send to IRIS

			$tbigriris_post_arr = array(

				'currency'      	=> 'EUR',

				'description'      	=> 'TBI IRIS Payment',

				'hookUrl'      		=> $tbigr_url . '?order=' . $paramstbigradd['newid'],

				'name'   			=> '',

				'redirectUrl'		=> Tools::getShopDomainSsl(true, true).'/index.php?controller=order',

				'sum'				=> $tbigr_products_price,

				'toIban'         	=> $tbigr_iris_iban

			);

			

			$tbigr_post = $tbigr_post_arr;

			if ($paramstbigr['tbi_testenv'] == 1){

				$tbigr_envurl = $paramstbigr['tbi_testurl'];

				$tbigr_env = 'tbi_test';

			}else{

				$tbigr_envurl = $paramstbigr['tbi_liveurl'];

				$tbigr_env = 'tbi_live';

			}

			

			if ($tbigr_type == 'IRIS'){

				$tbigr_post = $tbigriris_post_arr;

				if ($paramstbigr['iris_testenv'] == 1){

					$tbigr_envurl = $paramstbigr['iris_testurl'];

					$tbigr_env = 'iris_test';

				}else{

					$tbigr_envurl = $paramstbigr['iris_liveurl'];

					$tbigr_env = 'iris_live';

				}

			}

			

			$tbi_pause_txt = $paramstbigr['tbi_pause_txt'];

		}

		

		$cookie = new Cookie('tbigrpayment_cookie');

		$cookie->setExpire(time() + 20 * 60);

		$cookie->send_tbigr = 'No';

		$cookie->write();

		

		Tools::redirect($order_conf_link.$url_separator.'controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key.'&enc='.urlencode(base64_encode(json_encode($tbigr_post, JSON_UNESCAPED_UNICODE))).'&envurl='.$tbigr_envurl.'&tbi_pause_txt='.$tbi_pause_txt.'&tbigr_type='.$tbigr_type.'&tbigr_env='.$tbigr_env);

	}

}